Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /config/trunk/install.sh
ViewVC logotype

Diff of /config/trunk/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 515, Sun Jan 9 09:59:14 2000 UTC revision 1794, Wed May 18 16:59:22 2005 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/sh
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4    # Copyright (c) 2003 The Fellowship of SML/NJ
5  #  #
6  # installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
7  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
8  #  #
9    # Significant changes to take advantage of a new portable installer
10  #set -x  # script for everything after booting the interactive system.
   
11  #  #
12  # get the target list  # Author: Matthias Blume (blume@tti-c.org)
13  #  #
14  if [ ! -r config/targets ]; then  
15      echo "!!! File config/targets is missing."  if [ x$1 = xnolib ] ; then
16      exit 1      nolib=true
17    else
18        nolib=false
19    fi
20    
21    if [ x${INSTALL_QUIETLY} = xtrue ] ; then
22        export CM_VERBOSE
23        CM_VERBOSE=false
24  fi  fi
25  . config/targets  
26    vsay() {
27        if [ x${INSTALL_DEBUG} = xtrue ] ; then
28            echo "$@"
29        elif [ x${INSTALL_QUIETLY} = xtrue ] ; then
30            :
31        else
32            echo "$@"
33        fi
34    }
35    
36    complain() {
37        echo "$@"
38        exit 1
39    }
40    
41    this=$0
42    
43    
44  #  #
45  # create the preloads.standard file  # create the preloads.standard file
46  #  #
47  if [ ! -r config/preloads ]; then  if [ ! -r config/preloads ]; then
48      echo "!!! File config/preloads is missing."      complain "$this: !!! File config/preloads is missing."
     exit 1  
49  fi  fi
50  cp config/preloads preloads.standard  cp config/preloads preloads.standard
51    
52  #  #
53  # some OSs have make in strange places  # Some OSs have make in strange places, but most of the time it is
54    # simply on the PATH:
55  #  #
56  MAKE=make  MAKE=make
57    
 #  
 # check for ksh  
 #  
 # ksh causes some people problems so we will always use /bin/sh  
 #  
 #echo "checking for ksh"  
 #if [ -x /bin/ksh ]; then  
 #  SHELL=/bin/ksh  
 #elif [ -x /usr/local/bin/ksh ]; then  
 #  SHELL=/usr/local/bin/ksh  
 #else  
58    SHELL=/bin/sh    SHELL=/bin/sh
59  #fi  vsay $this: Using shell $SHELL.
 echo Using shell $SHELL.  
60    
61  #  #
62  # set the SML root directory  # set the SML root directory
63  #  #
64  REAL_PWD=`pwd`  REAL_PWD=`pwd`
65  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
66  echo SML root is $ROOT.  vsay $this: SML root is $ROOT.
67  echo Installation directory is ${INSTALLDIR:=$ROOT}.  
68    cd "${INSTALLDIR:=$ROOT}"
69    INSTALLDIR=`pwd`
70    cd "$ROOT"
71    vsay $this: Installation directory is ${INSTALLDIR}.
72    
73  #  #
74  # set the various directory and file pathname variables  # set the various directory and file pathname variables
# Line 63  Line 79 
79  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live
80  SRCDIR=$ROOT/src                # where the source tree is rooted  SRCDIR=$ROOT/src                # where the source tree is rooted
81  LIBDIR=$INSTALLDIR/lib          # where libraries live  LIBDIR=$INSTALLDIR/lib          # where libraries live
 LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries  
 LIBMOVESCRIPT=$ROOT/libmove     # a temporary script  
 LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file  
82    
83  #  #
84  # the paths to ml-yacc, ml-burg, and ml-lex; needed to configure CM  # files to be deleted after we are done...
85    #
86    tmpfiles=""
87    tmpfiles="$tmpfiles preloads.standard"
88  #  #
89  YACCPATH=$BINDIR/ml-yacc  # make sure we always clean up after ourselves...
90  LEXPATH=$BINDIR/ml-lex  #
91  BURGPATH=$BINDIR/ml-burg  trap 'cd "$ROOT"; rm -f $tmpfiles' 0 1 2 3 15
92    
93    
94  #  #
95  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
96  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
97  # Especially important is CM_PATHCONFIG_DEFAULT.  # Especially important is CM_PATHCONFIG.
98  #  #
99  CM_YACC_DEFAULT=$YACCPATH  export CM_PATHCONFIG
100  CM_LEX_DEFAULT=$LEXPATH  CM_PATHCONFIG=$LIBDIR/pathconfig
 CM_BURG_DEFAULT=$BURGPATH  
 CM_PATHCONFIG_DEFAULT=$LIBDIR/pathconfig  
 export CM_YACC_DEFAULT CM_LEX_DEFAULT CM_BURG_DEFAULT CM_PATHCONFIG_DEFAULT  
101    
102  #  #
103  # the release version that we are installing  # the release version that we are installing
104  #  #
105  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat "$CONFIGDIR/version"`
106  echo Installing version $VERSION.  vsay $this: Installing version $VERSION.
107    
108  #  #
109  # Function to make a directory (and advertise such action).  # the URL for the (usually remote) source archive
110  #  #
111  makedir() {  . "$CONFIGDIR"/srcarchiveurl
112      if [ ! -d $1 ] ; then  vsay $this: URL of source archive is $SRCARCHIVEURL.
         echo Making directory $1  
         if mkdir $1 ; then  
             : everything is fine  
         else  
             echo "!!! Unable to make directory $1!"  
             exit 1  
         fi  
     fi  
 }  
113    
114  #  #
115  # Function to unpack a source archive.  # Function to make a directory including its ancestors.
116  #  #
117  # $1: descriptive name of the sources to be unpacked  makedir() {
118  # $2: the directory into which to unpack the sources      if [ x"$1" = x ] ; then
119  # $3: the sub-directory of $2 that is going to be created by unpacking          :
120  # $4: the basename of the source archive (the script will check several      elif [ -d "$1" ] ; then
121  #     different suffixes to determine what kind of de-compression is to          :
122  #     be used)      else
123  unpack() {          makedirtmp=`dirname "$1"`
124      if [ ! -d $2/$3 ]; then          makedir "$makedirtmp"
125          echo Unpacking $1 source files.          if [ x${INSTALL_VERBOSE} = xtrue ] ; then
126          cd $2              vsay "$this: Making directory $1"
         if [ -r $4.tar.Z ] ; then  
             zcat $4.tar.Z | tar -xf -  
         elif [ -r $4.tar ] ; then  
             tar -xf $4.tar  
         elif [ -r $4.tar.gz ] ; then  
             gunzip -c $4.tar.gz | tar -xf -  
         elif [ -r $4.tar.bz2 ] ; then  
             bunzip2 -c $4.tar.bz2 | tar -xf -  
         elif [ -r $4.tgz ] ; then  
             gunzip -c $4.tgz | tar -xf -  
         elif [ -r $4.tz ] ; then  
             zcat $4.tz | tar -xf -  
         else  
             echo "!!! The $1 source files are missing."  
             exit 1  
127          fi          fi
128          if [ ! -d $2/$3 ]; then          if mkdir "$1" ; then
129              echo "!!! Unable to unpack $1 source files."              :
130              exit 1          else
131                complain "$this: !!! Unable to make directory $1!"
132          fi          fi
133      fi      fi
134  }  }
135    
136  #  #
137  # Move the stable archive of a library whose description file was $1/$2 to  # Fish out the CM metadata directory name from library files
138  # $LIBDIR/$2/CM/$ARCH-unix/$2 so that it appears as if the description file  # and store it in ORIG_CM_DIR_ARC.
139  # had been at $LIBDIR/$2/$2  # The single argument is the name of the directory containing
140  #  # a single subdirectory which is a CM metadata directory:
141  # (This script will also move all other libraries that show up in  #
142  #  $1/CM/$ARCH-unix because in the case of the boot directory this indicates  fish() {
143  #  that some library did not have its own path anchor but was specified      cd "$1"
144  #  relative to $1/$2. Still, don't rely on this to be robust -- rather make      ORIG_CM_DIR_ARC=unknown
145  #  separate anchors for every library!)      for i in * .[a-zA-Z0-9]* ; do
146  #          if [ -d $i ] ; then
147  movelibs() {              ORIG_CM_DIR_ARC=$i
148      for lib in `/bin/ls $1/CM/$ARCH-unix` ; do              break
149          case $lib in          fi
         *.cm)  
             if [ $lib != $2 ] ; then  
                 echo "! Warning:" $lib specified relative to $2  
             fi  
             echo Moving library $lib to $LIBDIR  
             makedir $LIBDIR/$2  
             makedir $LIBDIR/$2/CM  
             makedir $LIBDIR/$2/CM/$ARCH-unix  
             mv $1/CM/$ARCH-unix/$lib $LIBDIR/$2/CM/$ARCH-unix/$lib  
             ;;  
         *)  
             ;;  
         esac  
150       done       done
151        if [ $ORIG_CM_DIR_ARC = unknown ] ; then
152            complain "$this: could not determine CM metadata directory name"
153        else
154            echo "$this: CM metadata directory name is \"${ORIG_CM_DIR_ARC}\""
155        fi
156  }  }
157    
158  # A shell function that registers a library for being built.  
159  # This function takes two arguments: 1. a name under which the library  # A function to move all stable library files to a parallel directory
160  # is to be known later (something.cm) and 2. the path relative to $SRCDIR  # hierarchy.
161  # that leads to the library's .cm file.  The library's .cm file must be the  # The first argument must be a simple path (no / inside), and
162  # same as $1.  # the second argument must be an absolute path.
163  #  move() {
164  # This works by adding ML code to file $LIBLIST.  The code in this file      if [ -L "$1" ] ; then
165  # will be executed near the end of this script.  If $MOVE_LIBRARIES is          rm -f "$1"           # remove symbolic link made by diracs (see below)
166  # set to true, then reglib will also register a "movelibs" to be executed at      elif [ -d "$1" ] ; then
167  # the end by putting a "movelibs" line into $LIBMOVESCRIPT.          if [ ! -d "$2" ] ; then
168                if [ -f "$2" ] ; then
169  reglib() {                  complain $this: $2 exists as a non-directory.
170      if [ x$MOVE_LIBRARIES = xtrue ] ; then              fi
171          FINALLOCATION=$LIBDIR/$1              mkdir "$2"
172      else          fi
173          FINALLOCATION=$SRCDIR/$2          cd "$1"
174      fi          for i in * .[a-zA-Z0-9]* ; do
175      if [ -d $FINALLOCATION/CM/$ARCH-unix ] ; then              move "$i" "$2"/"$i"
176          echo "Library $1 already exists in $FINALLOCATION."          done
177      else          cd ..
178          echo "Scheduling library $1 to be built in $FINALLOCATION."      elif [ -f "$1" ] ; then
179          echo "andalso CM.stabilize false \"$1\"" >>$LIBLIST          rm -f "$2"
180          echo $1 $SRCDIR/$2 >>$LOCALPATHCONFIG          mv "$1" "$2"
         if [ x$MOVE_LIBRARIES = xtrue ] ; then  
             echo movelibs $SRCDIR/$2 $1 >>$LIBMOVESCRIPT  
         fi  
         echo $1 $FINALLOCATION >>$CM_PATHCONFIG_DEFAULT  
181      fi      fi
182  }  }
183    
184  #  #
185  # Function to build a standalone program such as ml-yacc.  The function takes  # Traverse the directory tree rooted at $3 (must be single arc!).
186  # 2 or 3 arguments.  First the name of the program which at the same time  # Find all directories named $1, rename them into $2 and make
187  # is the directory name under $SRCDIR where the sources reside.  The second  # and establish $1 as a symbolic link to $2:
188  # argument is a descriptive name for the program (passed on to "unpack").  #
189  # The optional third argument specifies the path relative to $SRCDIR/$1  dirarcs() {
190  # of the directory where the program's heap image is to be found.      if [ -d "$3" ] ; then
191  #          if [ "$3" = "$1" ] ; then
192                mv "$1" "$2"
193  standalone() {              ln -s "$2" "$1"
194      TARGET=$1.$HEAP_SUFFIX          else
195      if [ $# = 3 ] ; then              cd "$3"
196          TARGETLOC=$3/$TARGET              for d in * .[a-zA-Z0-9]* ; do
197      else                  dirarcs "$1" "$2" "$d"
198          TARGETLOC=$TARGET              done
199      fi              cd ..
     if [ -r $HEAPDIR/$TARGET ] ; then  
         echo Target $TARGET already exists.  
     else  
         echo Building $TARGET.  
         unpack $2 $SRCDIR $1 $ROOT/$VERSION-$1  
         cd $SRCDIR/$1  
         ./build  
         if [ -r $TARGETLOC ] ; then  
             mv $TARGETLOC $HEAPDIR/$TARGET  
             if [ ! -f $BINDIR/$1 ] ; then  
                 cd $BINDIR  
                 ln -s .run-sml $1  
             fi  
         else  
             echo "!!! Build of $TARGET failed."  
200          fi          fi
201      fi      fi
202  }  }
203    
204    
205    ######################################################################
206    
207  #  #
208  # create the various sub directories  # create the various sub directories
209  #  #
210  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR  for dir in "$BINDIR" "$HEAPDIR" "$RUNDIR" "$LIBDIR" "$SRCDIR" ; do
211  do      makedir "$dir"
     makedir $dir  
212  done  done
213    
214    #
215    # Function to install a "driver" script...
216    #   This takes care of patching the source of the script with the SHELL,
217    #   BINDIR, and VERSION variables to use.
218    #
219    installdriver() {
220        dsrc=$1
221        ddst=$2
222    # We install the driver unconditionally. (It would be better to test
223    # for an outdated driver script, but not all "test" commands understand
224    # the -nt comparison operator....)
225    #   if [ -x $BINDIR/$ddst ]; then
226    #       echo $this: Script $BINDIR/$ddst already exists.
227    #   else
228            rm -f "$BINDIR"/"$ddst"
229            cat "$CONFIGDIR"/"$dsrc" | \
230            sed -e "s,@SHELL@,$SHELL,g" \
231                -e "s,@BINDIR@,$BINDIR," \
232                -e "s,@VERSION@,$VERSION," \
233                -e "s,@CMDIRARC@,${CM_DIR_ARC:-dummy}," \
234                > "$BINDIR"/"$ddst"
235            chmod 555 "$BINDIR"/"$ddst"
236            if [ ! -x "$BINDIR"/"$ddst" ]; then
237                complain "$this: !!! Installation of $BINDIR/${ddst} failed."
238            fi
239    #   fi
240    }
241    
242  #  #
243  # install the script that tests the architecture, and make sure that it works  # install the script that tests architecture and os...
244  #  #
245  if [ -x $BINDIR/.arch-n-opsys ]; then  installdriver _arch-n-opsys .arch-n-opsys
246    echo Script $BINDIR/.arch-n-opsys already exists.  
247  else  #
248    cat $CONFIGDIR/_arch-n-opsys | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys  # run it to figure out what architecture and os we are using, define
249    chmod 555 $BINDIR/.arch-n-opsys  # corresponding variables...
250    if [ ! -x $BINDIR/.arch-n-opsys ]; then  #
251      echo "!!! Installation of $BINDIR/.arch-n-opsys failed for some reason."  ARCH_N_OPSYS=`"$BINDIR"/.arch-n-opsys`
     exit 1  
   fi  
 fi  
 ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  
252  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
253    echo "!!! Script $BINDIR/.arch-n-opsys fails on this machine."      echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
254    echo "!!! You must patch this by hand and repeat the installation."      echo "$this: !!! You must patch this by hand and repeat the installation."
255    exit 2    exit 2
256  else  else
257    echo Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.      vsay $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
258  fi  fi
259  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
260    
261  if [ -x $BINDIR/.run-sml ]; then  #
262    echo Script $BINDIR/.run-sml already exists.  # now install most of the other driver scripts
263  else  #  (except ml-build, since we don't know $CM_DIR_ARC yet)
264    cat $CONFIGDIR/_run-sml | \  #
265      sed -e "s,@SHELL@,$SHELL,g" -e "s,@BINDIR@,$BINDIR," -e "s,@VERSION@,$VERSION," \  installdriver _run-sml .run-sml
266      > $BINDIR/.run-sml  installdriver _link-sml .link-sml
267    chmod 555 $BINDIR/.run-sml  installdriver _ml-makedepend ml-makedepend
268    if [ ! -x $BINDIR/.run-sml ]; then  
269      echo "!!! Installation of $BINDIR/.run-sml failed for some reason."  installdriver _heap2exec heap2exec
     exit 1  
   fi  
 fi  
270    
271  #  #
272  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
273  #  #
274  case $ARCH in  case $ARCH in
275    mips*) ALLOC=1M ;;      mips*)
276            ALLOC=1M
277            ;;
278    x86)    x86)
279            # The following is the _wrong_ value for many popular x86 chips
280            # (i.e., Celerons).  However, the optimal value for those is 32k,
281            # and such a small value is not enough for the runtime system's boot
282            # code.  Therefore, we use 256k here and re-set it to the proper
283            # value in .run-sml.
284      ALLOC=256k      ALLOC=256k
285    ;;    ;;
286    alpha32)    alpha32)
# Line 297  Line 290 
290      ALLOC=512k      ALLOC=512k
291    ;;    ;;
292  esac  esac
293    
294  case $OPSYS in  case $OPSYS in
295    solaris)    solaris)
296      MAKE=/usr/ccs/bin/make      MAKE=/usr/ccs/bin/make
# Line 304  Line 298 
298    linux)    linux)
299      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
300      if [ "$?" != "0" ]; then      if [ "$?" != "0" ]; then
301        echo "!!! Problems checking for underscores in global names."              complain "$this: !!! Problems checking for underscores in asm names."
       exit 1  
302      fi      fi
303      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
304    ;;    ;;
# Line 314  Line 307 
307  #  #
308  # the name of the bin files directory  # the name of the bin files directory
309  #  #
310  BOOT_FILES=sml.boot.$ARCH-unix  BOOT_ARCHIVE=boot.$ARCH-unix
311    BOOT_FILES=sml.$BOOT_ARCHIVE
312    
313  #  #
314  # build the run-time system  # build the run-time system
315  #  #
316  unpack "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime  if [ -x "$RUNDIR"/run.$ARCH-$OPSYS ]; then
317  if [ ! -x $RUNDIR/run.$ARCH-$OPSYS ]; then      vsay $this: Run-time system already exists.
318    cd $SRCDIR/runtime/objs  else
319    echo Compiling the run-time system.      "$CONFIGDIR"/unpack "$ROOT" runtime
320        cd "$SRCDIR"/runtime/objs
321        echo $this: Compiling the run-time system.
322    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
323    if [ -x run.$ARCH-$OPSYS ]; then    if [ -x run.$ARCH-$OPSYS ]; then
324      mv run.$ARCH-$OPSYS $RUNDIR          mv run.$ARCH-$OPSYS "$RUNDIR"
325      # $MAKE MAKE=$MAKE clean          if [ -f runx.$ARCH-$OPSYS ]; then
326                mv runx.$ARCH-$OPSYS "$RUNDIR"
327            fi
328            $MAKE MAKE=$MAKE clean
329    else    else
330      echo "!!! Run-time system build failed for some reason."          complain "$this: !!! Run-time system build failed for some reason."
     exit 1  
331    fi    fi
332  fi  fi
333  cd $SRCDIR  cd "$SRCDIR"
334    
335  #  #
336  # boot the base SML system  # boot the base SML system
337  #  #
338  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r "$HEAPDIR"/sml.$HEAP_SUFFIX ]; then
339    echo Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.      vsay $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
340        fish "$LIBDIR"/basis.cm
341        # ignore requested arc name since we have to live with what is there:
342        export CM_DIR_ARC
343        CM_DIR_ARC=$ORIG_CM_DIR_ARC
344        # now re-dump the heap image:
345        vsay "$this: Re-creating a (customized) heap image..."
346        "$BINDIR"/sml @CMredump "$ROOT"/sml
347        cd "$ROOT"
348        if [ -r sml.$HEAP_SUFFIX ]; then
349            mv sml.$HEAP_SUFFIX "$HEAPDIR"
350        else
351            complain "$this !!! Unable to re-create heap image (sml.$HEAP_SUFFIX)."
352        fi
353  else  else
354    unpack bin $ROOT $BOOT_FILES $ROOT/$VERSION-$BOOT_FILES      "$CONFIGDIR"/unpack "$ROOT" "$BOOT_ARCHIVE"
355    cd $ROOT  
356    if $RUNDIR/run.$ARCH-$OPSYS @SMLheap=sml \      fish "$ROOT"/"$BOOT_FILES"/basis.cm
357          @SMLboot=$ROOT/$BOOT_FILES @SMLrtpid=`cat $BOOT_FILES/RTPID` \  
358          @SMLalloc=$ALLOC      cd "$ROOT"
359    
360        # Target arc:
361        export CM_DIR_ARC
362        CM_DIR_ARC=${CM_DIR_ARC:-".cm"}
363    
364        if [ $CM_DIR_ARC = $ORIG_CM_DIR_ARC ] ; then
365            : we are happy
366        else
367            # now we have to make a symbolic link for each occurrence of
368            # $ORIG_CM_DIR_ARC to $CM_DIR_ARC
369            dirarcs "$ORIG_CM_DIR_ARC" "$CM_DIR_ARC" "$BOOT_FILES"
370        fi
371    
372        cd "$ROOT"/"$BOOT_FILES"
373    
374        # now link (boot) the system and let it initialize itself...
375        if "$BINDIR"/.link-sml @SMLheap="$ROOT"/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
376    then    then
377            cd "$ROOT"
378      if [ -r sml.$HEAP_SUFFIX ]; then      if [ -r sml.$HEAP_SUFFIX ]; then
379          mv sml.$HEAP_SUFFIX $HEAPDIR              mv sml.$HEAP_SUFFIX "$HEAPDIR"
380          cd $BINDIR              cd "$BINDIR"
381          ln -s .run-sml sml          ln -s .run-sml sml
   
382          #          #
383          # Now move all stable libraries to #LIBDIR and generate          # Now move all stable libraries to #LIBDIR and generate
384          # the pathconfig file.          # the pathconfig file.
385          #          #
386                cd "$ROOT"/"$BOOT_FILES"
387          cd $ROOT/$BOOT_FILES              for anchor in * ; do
388          for lib in *.cm ; do                  if [ -d $anchor ] ; then
389              echo $lib $LIBDIR/$lib >>$CM_PATHCONFIG_DEFAULT                      echo $anchor $anchor >>$CM_PATHCONFIG
390              movelibs $ROOT/$BOOT_FILES/$lib $lib                      move $anchor "$LIBDIR"/$anchor
391                    fi
392          done          done
393          cd $ROOT              cd "$ROOT"
394          # rm -rf $BOOT_FILES              # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
395                rm -rf "$BOOT_FILES"
396    
397      else      else
398          echo "!!! Boot code did not produce heap image (sml.$HEAP_SUFFIX)."              complain "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
         exit 1  
399      fi      fi
400    else    else
401      echo "!!! Boot code failed, no heap image built (sml.$HEAP_SUFFIX)."          complain "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
     exit 1  
402    fi    fi
403  fi  fi
404    
405  #  #
406  # Initialize $LIBLIST  # now that we know CM_DIR_ARC we can install the ml-build driver...
407  #  #
408  cd $ROOT  installdriver _ml-build ml-build
 rm -f $LOCALPATHCONFIG $LIBLIST  
 echo 'OS.Process.exit (if true' >$LIBLIST  
   
 #  
 # now build (or prepare to build) the individual targets  
 #  
 cd $SRCDIR  
 echo Installing other targets.  
 for i in $TARGETS ; do  
     case $i in  
       src-smlnj)  
         for src in compiler cm MLRISC smlnj-lib ml-yacc system  
         do  
             unpack $src $ROOT/src $src $ROOT/$VERSION-$src  
         done  
         ;;  
       ml-yacc)  
         standalone ml-yacc ML-Yacc src  
         ;;  
       ml-lex)  
         standalone ml-lex ML-Lex  
         ;;  
       ml-burg)  
         standalone ml-burg ML-Burg  
         ;;  
       smlnj-lib)  
         unpack "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib  
409    
410          # Don't make the Util library -- it came pre-made and has been  cd "$ROOT"
         # installed when making the base system.  In other words, don't do...  
             #reglib smlnj-lib.cm smlnj-lib/Util  
         # ... and don't make the HTML library ...  
             #reglib html-lib.cm smlnj-lib/HTML  
         # ... and don't make the PP library ...  
             #reglib pp-lib.cm smlnj-lib/PP  
         # make the Unix library  
             reglib unix-lib.cm smlnj-lib/Unix  
         # make the INet library  
             reglib inet-lib.cm smlnj-lib/INet  
         # make the RegExp library  
             reglib regexp-lib.cm smlnj-lib/RegExp  
         # make the Reactive library  
             reglib reactive-lib.cm smlnj-lib/Reactive  
         ;;  
       cml)  
         unpack CML $SRCDIR cml $ROOT/$VERSION-cml  
         reglib core-cml.cm cml/src/core-cml  
         reglib cml.cm cml/src  
         reglib cml-basis.cm cml  
         ;;  
       cml-lib)  
         unpack CML $SRCDIR cml $ROOT/$VERSION-cml  
         reglib cml-lib.cm cml/cml-lib  
         ;;  
       eXene)  
         unpack EXene $SRCDIR eXene $ROOT/$VERSION-eXene  
         reglib eXene.cm eXene  
         ;;  
       doc)  
         unpack Doc $ROOT doc $ROOT/$VERSION-doc  
         cd $ROOT/doc  
         build $ROOT  
         ;;  
       *)  
         echo "!!! Unknown target $i."  
         ;;  
     esac  
 done  
411    
412  #  #
413  # Now go and stabilize all registered libraries...  # Now do all the rest using the precompiled installer:
 # This is done with library sources in their original locations inside  
 # $SRCDIR, so we must consult $LOCALPATHCONFIG.  
414  #  #
415    if [ $nolib = false ] ; then
416  echo Compiling library code.      echo $this: Installing other libraries and programs:
417  echo 'then OS.Process.success else OS.Process.failure);' >>$LIBLIST      export ROOT INSTALLDIR CONFIGDIR BINDIR
418  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then      if "$BINDIR"/sml -m \$smlnj/installer.cm
419      echo Libraries compiled successfully.      then
420            vsay $this: Installation complete.
421  else  else
422      echo "!!! Something went wrong when compiling the libraries."          complain "$this: !!! Installation of libraries and programs failed."
     exit 1  
423  fi  fi
 rm -f $LIBLIST $LOCALPATHCONFIG  
   
 #  
 # Finally, move the libraries to their final locations...  
 #  
   
 if [ -r $LIBMOVESCRIPT ] ; then  
     echo Moving libraries to $LIBDIR.  
     . $LIBMOVESCRIPT  
     rm -f $LIBMOVESCRIPT  
424  fi  fi
425    
426  #  exit 0
 # Get rid of preloads.standard  
 #  
 rm -f $ROOT/preloads.standard  

Legend:
Removed from v.515  
changed lines
  Added in v.1794

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0